
function [data ind numcens]=BY_generate_y(obs, model)

months=obs+120+14+1; 
ind=0; 
numcens=0; 

% Benchmark model
if model == 1
    gamma = 1.516;
    psi = 1.4567;
    delta = .99795;
    sigma_c = 0.0069004;
    mu = 0.0015644;
    pi_cl = 0;
    sigma_d = 2.478552; % AELR report this as a standard deviation instead of as a multiplier on sigma_c.
    pi_dc = 0.071194; % AELR report this as a standard deviation instead of as a multiplier on sigma_c.
    pi_dl = 0;
    sigma_eta = 0;
    rho_lambda = 0.99132;
    sigma_lambda = 0.00058631;
    nu = 0;
    sigma_omega = 0;
    alpha_c = 0;
    alpha_d = 0;
    rho_c = 0;
    rho_d = 0;

% Extended model
elseif model == 2
    gamma = 2.3961;
    psi = 2.2107;
    delta = .99796;
    sigma_c = 0.0046033;
    mu = 0.0010428;
    pi_cl = -.0029185;
    sigma_d = 0.025274;
    pi_dc = -1.3205;
    pi_dl = -0.010907;
    sigma_eta = 0.0077828;
    rho_lambda = 0.99168;
    sigma_lambda = 0.00038594;
    nu = 0.99717;
    sigma_omega = 0.00000168;
    alpha_c = -95.3767;
    alpha_d = -151.8814;
    rho_c = 0.094708;
    rho_d = 0.33427;

% Benchmark model without valuation risk
elseif model == 3
    gamma = 1.516;
    psi = 1.4567;
    delta = .99795;
    sigma_c = 0.0069004;
    mu = 0.0015644;
    pi_cl = 0;
    sigma_d = 2.478552; % AELR report this as a standard deviation instead of as a multiplier on sigma_c.
    pi_dc = 0.071194; % AELR report this as a standard deviation instead of as a multiplier on sigma_c.
    pi_dl = 0;
    sigma_eta = 0;
    rho_lambda = 0.99132;
    sigma_lambda = 0; % Set to 0 to shut down valuation risk
    nu = 0;
    sigma_omega = 0;
    alpha_c = 0;
    alpha_d = 0;
    rho_c = 0;
    rho_d = 0;

% Extended model without valuation risk
elseif model == 4
    gamma = 2.3961;
    psi = 2.2107;
    delta = .99796;
    sigma_c = 0.0046033;
    mu = 0.0010428;
    pi_cl = -.0029185;
    sigma_d = 0.025274;
    pi_dc = -1.3205;
    pi_dl = -0.010907;
    sigma_eta = 0; % Set to 0 to shut down valuation risk
    rho_lambda = 0.99168;
    sigma_lambda = 0; % Set to 0 to shut down valuation risk
    nu = 0.99717;
    sigma_omega = 0.00000168;
    alpha_c = -95.3767;
    alpha_d = -151.8814;
    rho_c = 0.094708;
    rho_d = 0.33427;

% Extended model without long-run risk
elseif model == 5
    gamma = 2.3961;
    psi = 2.2107;
    delta = .99796;
    sigma_c = 0.0046033;
    mu = 0.0010428;
    pi_cl = -.0029185;
    sigma_d = 0.025274;
    pi_dc = -1.3205;
    pi_dl = -0.010907;
    sigma_eta = 0.0077828;
    rho_lambda = 0.99168;
    sigma_lambda = 0.00038594;
    nu = 0.99717;
    sigma_omega = 0.00000168;
    alpha_c = 0; % Set to 0 to shut down long-run risk
    alpha_d = 0; % Set to 0 to shut down long-run risk
    rho_c = 0.094708;
    rho_d = 0.33427;
    
% Extended model without valuation risk or long-run risk
elseif model == 6
    gamma = 2.3961;
    psi = 2.2107;
    delta = .99796;
    sigma_c = 0.0046033;
    mu = 0.0010428;
    pi_cl = -.0029185;
    sigma_d = 0.025274;
    pi_dc = -1.3205;
    pi_dl = -0.010907;
    sigma_eta = 0; % Set to 0 to shut down valuation risk
    rho_lambda = 0.99168;
    sigma_lambda = 0; % Set to 0 to shut down valuation risk
    nu = 0.99717;
    sigma_omega = 0.00000168;
    alpha_c = 0; % Set to 0 to shut down long-run risk
    alpha_d = 0; % Set to 0 to shut down long-run risk
    rho_c = 0.094708;
    rho_d = 0.33427;

% Extended model without long-run risk, homoscedastic
elseif model == 7
    gamma = 2.3961;
    psi = 2.2107;
    delta = .99796;
    sigma_c = 0.0046033;
    mu = 0.0010428;
    pi_cl = -.0029185;
    sigma_d = 0.025274;
    pi_dc = -1.3205;
    pi_dl = -0.010907;
    sigma_eta = 0.0077828;
    rho_lambda = 0.99168;
    sigma_lambda = 0.00038594;
    nu = 0.99717;
    sigma_omega = 0; % Set to 0 to shut down stochastic volatility
    alpha_c = 0; % Set to 0 to shut down long-run risk
    alpha_d = 0; % Set to 0 to shut down long-run risk
    rho_c = 0.094708;
    rho_d = 0.33427;

% Extended model without valuation risk or long-run risk, homoscedastic
elseif model == 8
    gamma = 2.3961;
    psi = 2.2107;
    delta = .99796;
    sigma_c = 0.0046033;
    mu = 0.0010428;
    pi_cl = -.0029185;
    sigma_d = 0.025274;
    pi_dc = -1.3205;
    pi_dl = -0.010907;
    sigma_eta = 0; % Set to 0 to shut down valuation risk
    rho_lambda = 0.99168;
    sigma_lambda = 0; % Set to 0 to shut down valuation risk
    nu = 0.99717;
    sigma_omega = 0; % Set to 0 to shut down stochastic volatility
    alpha_c = 0; % Set to 0 to shut down long-run risk
    alpha_d = 0; % Set to 0 to shut down long-run risk
    rho_c = 0.094708;
    rho_d = 0.33427;
end

mu_c = mu;
mu_d = mu*(1-rho_d)/(1-rho_c);
sigma = sigma_c;

theta = (1-gamma)/(1-1/psi);


% Numerically solve for value of coefficients in equations IA.12 - IA.17 by
% iterating to find fixed points.

zc_mean = 6;
i=0; 

while i<=1000
    kc1 = exp(zc_mean) / (1 + exp(zc_mean)); 
    kc0 = log(1 + exp(zc_mean)) - kc1*zc_mean;
    Ac1 = 1 / (1 - kc1*rho_lambda);
    Ac2 = sigma_eta;
    Ac3 = (alpha_c*nu + ((1-gamma)/(1-kc1*rho_c))/2)/(1-kc1*nu) ...
        *(1-1/psi)/(1-kc1*rho_c);
    Ac4 = (1-1/psi)*rho_c/(1-kc1*rho_c);
    Ac5 = 0;
    Ac0 = (log(delta) ...
        - (1 - 1/psi + kc1*Ac4)*alpha_c*sigma^2 ...
        + ((1 - 1/psi + kc1*Ac4)*alpha_c + kc1*Ac3)*(1-nu)*sigma^2 ...
        + theta*((1 - 1/psi + kc1*Ac4)*pi_cl + kc1*Ac1*sigma_lambda)^2/2 ...
        + theta*((1 - 1/psi +kc1*Ac4)*alpha_c + kc1*Ac3)^2*sigma_omega^2/2 ...
        + (1 - 1/psi + kc1*Ac4)*mu ...
        + theta*(kc1*Ac2)^2/2 ...
        + kc0) ...
        / (1 - kc1);
    zc_mean = Ac0 + Ac3*sigma^2 + Ac4*mu_c/(1-rho_c);
    i=i+1; 
end

gamma_tilda = gamma - (theta-1)*kc1*Ac4; 

zd_mean=6; 
i=0;
 
while i<=1000
    kd1 = exp(zd_mean) / (1 + exp(zd_mean));
    kd0 = log(1 + exp(zd_mean)) - kd1*zd_mean;
    Ad1 = 1 / (1 - kd1*rho_lambda);
    Ad2 = sigma_eta;
    Ad4 = -(1/psi)*rho_c/(1-kd1*rho_c);
    Ad5 = rho_d / (1 - kd1*rho_d);
    gamma_hat = gamma - (theta-1)*kc1*Ac4 - kd1*Ad4;
    Ad3 = ((1 + kd1*Ad5)*alpha_d*nu ...
        - gamma_hat*alpha_c*nu ...
        - (alpha_c*nu + ((1-gamma)/(1-kc1*rho_c))/2)*(1/psi-gamma)/(1-kc1*rho_c) ...
        + (1 + kd1*Ad5)^2*sigma_d^2/2 ...
        + ((1 + kd1*Ad5)*pi_dc - gamma_hat)^2/2) ...
        / (1-kd1*nu);
    Ad6 = 0;
    Ad0 = (theta*log(delta) ...
        - gamma_hat*mu_c ...
        + (1 + kd1*Ad5)*mu_d ...
        - ((1 + kd1*Ad5)*alpha_d - gamma_hat*alpha_c)*sigma^2 ...
        + (theta-1)*(kc1-1)*Ac0 ...
        + ((1 + kd1*Ad5)*alpha_d - gamma_hat*alpha_c + (theta-1)*kc1*Ac3 + kd1*Ad3)*(1-nu)*sigma^2 ...
        + kd0 ...
        + (theta-1)*kc0 ...
        + ((1 + kd1*Ad5)*pi_dl - gamma_hat*pi_cl + ((theta-1)*kc1*Ac1 + kd1*Ad1)*sigma_lambda)^2/2 ...
        + ((1 + kd1*Ad5)*alpha_d - gamma_hat*alpha_c + (theta-1)*kc1*Ac3 + kd1*Ad3)^2*sigma_omega^2/2 ...
        + ((theta-1)*kc1*Ac2 + kd1*Ad2)^2/2) ...
        / (1 - kd1);
    zd_mean = Ad0 + Ad3*sigma^2 + Ad4*mu_c/(1-rho_c) + Ad5*mu_d/(1-rho_d); % AELR IA appears to be missing Ad5 term.
    i=i+1;
end


epsilon_c = randn(months, 1);
epsilon_d = randn(months, 1);
epsilon_lambda = randn(months, 1);
omega = randn(months, 1);
eta = randn(months, 1);


sigma2t = zeros(months,1);
delta_c = zeros(months,1);
delta_d = zeros(months,1);
delta_lambda = zeros(months,1);
x = zeros(months,1);

c = zeros(months,1);
d = ones(months,1);

rd=zeros(months,1);
rf=zeros(months,1);
zc=zeros(months,1);
zd=zeros(months,1);
epremium=zeros(months,1); 


sigma2t(1,1)=sigma^2;
for i=2:months
    sigma2t(i,1) = sigma^2 + nu*(sigma2t(i-1,1)-sigma^2) + sigma_omega*omega(i,1);
    if sigma2t(i,1)<=0
        if i>=123
            ind=1; 
            numcens=numcens+1; 
        end
    end
    delta_c(i,1) = mu_c + rho_c*delta_c(i-1,1) + alpha_c*(sigma2t(i,1)-sigma^2) ...
        + pi_cl*epsilon_lambda(i,1) ...
        + max(sigma2t(i-1,1),.0000000000001).^0.5.*epsilon_c(i,1);
    delta_d(i,1) = mu_d + rho_d*delta_d(i-1,1) + alpha_d*(sigma2t(i,1)-sigma^2) ...
        + sigma_d*max(sigma2t(i-1,1),.0000000000001).^0.5.*epsilon_d(i,1) ...
        + pi_dl*epsilon_lambda(i,1) + pi_dc*max(sigma2t(i-1,1),.0000000000001).^0.5.*epsilon_c(i,1);
    delta_lambda(i,1) = x(i-1,1) + sigma_eta*eta(i,1);
    x(i,1) = rho_lambda*x(i-1,1) + sigma_lambda*epsilon_lambda(i,1);
end

for i=2:months-1
    zc(i,1) = Ac0 + Ac1*x(i,1) + Ac2*eta(i+1,1) + Ac3*sigma2t(i,1) + Ac4*delta_c(i,1);
    zd(i,1) = Ad0 + Ad1*x(i,1) + Ad2*eta(i+1,1) + Ad3*sigma2t(i,1) + Ad4*delta_c(i,1) + Ad5*delta_d(i,1);
end

for i=3:months-1
    rd(i,1) = kd0 + kd1*zd(i,1) - zd(i-1,1) + delta_d(i,1);
    rf(i,1) = -theta*log(delta) ...
        + gamma_tilda*mu_c ...
        - gamma_tilda*alpha_c*sigma^2 ...
        - ((theta-1)*kc1*Ac2)^2/2 ...
        - ((theta-1)*kc1*Ac1*sigma_lambda - gamma_tilda*pi_cl)^2/2 ...
        - (theta-1)*kc0 ...
        - (theta-1)*(kc1-1)*Ac0 ...
        - ((theta-1)*kc1*Ac3 - gamma_tilda*alpha_c)*(1-nu)*sigma^2 ...
        - ((theta-1)*kc1*Ac3 - gamma_tilda*alpha_c)^2*sigma_omega^2/2 ...
        - delta_lambda(i,1) ...
        + (1/psi)*rho_c*delta_c(i-1,1) ...
        + (theta-1)*Ac3*sigma2t(i-1,1) ...
        - gamma_tilda^2*sigma2t(i-1,1)/2 ...
        - ((theta-1)*kc1*Ac3 - gamma_tilda*alpha_c)*nu*sigma2t(i-1,1);
    epremium(i,1)=rd(i,1)-rf(i,1);
    c(i,1)=c(i-1,1)+delta_c(i,1); 
    d(i,1)=d(i-1,1)+delta_d(i,1); 
end

c=c(123:months-1,1);
d=d(123:months-1,1);
rf=rf(123:months-1,1);
rd=rd(123:months-1,1);
zd=zd(123:months-1,1);
epremium=epremium(123:months-1,1);  

cg=zeros((months-134-1)/12,1); 
dg=zeros((months-134-1)/12,1);
pd=zeros((months-134-1)/12,1); 
ir=zeros((months-134-1)/12,1);
ret=zeros((months-134-1)/12,1);
er=zeros((months-134-1)/12,1);

for k=1:(months-134-1)/12
    cg(k,1)=log((exp(c(k*12+12,1)-c(k*12-11,1))+exp(c(k*12+11,1)-c(k*12-11,1))+exp(c(k*12+10,1)-c(k*12-11,1))+exp(c(k*12+9,1)-c(k*12-11,1))+...
        exp(c(k*12+8,1)-c(k*12-11,1))+exp(c(k*12+7,1)-c(k*12-11,1))+exp(c(k*12+6,1)-c(k*12-11,1))+exp(c(k*12+5,1)-c(k*12-11,1))+...
        exp(c(k*12+4,1)-c(k*12-11,1))+exp(c(k*12+3,1)-c(k*12-11,1))+exp(c(k*12+2,1)-c(k*12-11,1))+exp(c(k*12+1,1)-c(k*12-11,1)))/(...
        exp(c(k*12,1)-c(k*12-11,1))+exp(c(k*12-1,1)-c(k*12-11,1))+exp(c(k*12-2,1)-c(k*12-11,1))+exp(c(k*12-3,1)-c(k*12-11,1))+...
        exp(c(k*12-4,1)-c(k*12-11,1))+exp(c(k*12-5,1)-c(k*12-11,1))+exp(c(k*12-6,1)-c(k*12-11,1))+exp(c(k*12-7,1)-c(k*12-11,1))+...
        exp(c(k*12-8,1)-c(k*12-11,1))+exp(c(k*12-9,1)-c(k*12-11,1))+exp(c(k*12-10,1)-c(k*12-11,1))+exp(c(k*12-11,1)-c(k*12-11,1)))); 

    dg(k,1)=log((exp(d(k*12+12,1)-d(k*12-11,1))+exp(d(k*12+11,1)-d(k*12-11,1))+exp(d(k*12+10,1)-d(k*12-11,1))+exp(d(k*12+9,1)-d(k*12-11,1))+...
        exp(d(k*12+8,1)-d(k*12-11,1))+exp(d(k*12+7,1)-d(k*12-11,1))+exp(d(k*12+6,1)-d(k*12-11,1))+exp(d(k*12+5,1)-d(k*12-11,1))+...
        exp(d(k*12+4,1)-d(k*12-11,1))+exp(d(k*12+3,1)-d(k*12-11,1))+exp(d(k*12+2,1)-d(k*12-11,1))+exp(d(k*12+1,1)-d(k*12-11,1)))/(...
        exp(d(k*12,1)-d(k*12-11,1))+exp(d(k*12-1,1)-d(k*12-11,1))+exp(d(k*12-2,1)-d(k*12-11,1))+exp(d(k*12-3,1)-d(k*12-11,1))+...
        exp(d(k*12-4,1)-d(k*12-11,1))+exp(d(k*12-5,1)-d(k*12-11,1))+exp(d(k*12-6,1)-d(k*12-11,1))+exp(d(k*12-7,1)-d(k*12-11,1))+...
        exp(d(k*12-8,1)-d(k*12-11,1))+exp(d(k*12-9,1)-d(k*12-11,1))+exp(d(k*12-10,1)-d(k*12-11,1))+exp(d(k*12-11,1)-d(k*12-11,1)))); 

    pd(k,1)=log(exp(zd(k*12+12,1))*exp(d(k*12+12,1)-d(k*12-11,1))/(exp(d(k*12+12,1)-d(k*12-11,1))+exp(d(k*12+11,1)-d(k*12-11,1))+...
        exp(d(k*12+10,1)-d(k*12-11,1))+exp(d(k*12+9,1)-d(k*12-11,1))+...
        exp(d(k*12+8,1)-d(k*12-11,1))+exp(d(k*12+7,1)-d(k*12-11,1))+exp(d(k*12+6,1)-d(k*12-11,1))+exp(d(k*12+5,1)-d(k*12-11,1))+...
        exp(d(k*12+4,1)-d(k*12-11,1))+exp(d(k*12+3,1)-d(k*12-11,1))+exp(d(k*12+2,1)-d(k*12-11,1))+exp(d(k*12+1,1)-d(k*12-11,1))));

    ir(k,1)=rf(k*12+12,1)+rf(k*12+11,1)+rf(k*12+10,1)+rf(k*12+9,1)+rf(k*12+8,1)+rf(k*12+7,1)+rf(k*12+6,1)+rf(k*12+5,1)+rf(k*12+4,1)+rf(k*12+3,1)...
        +rf(k*12+2,1)+rf(k*12+1,1); 

    ret(k,1)=rd(k*12+12,1)+rd(k*12+11,1)+rd(k*12+10,1)+rd(k*12+9,1)+rd(k*12+8,1)+rd(k*12+7,1)+rd(k*12+6,1)+rd(k*12+5,1)+...
        rd(k*12+4,1)+rd(k*12+3,1)+rd(k*12+2,1)+rd(k*12+1,1); 

    er(k,1)=epremium(k*12+12,1)+epremium(k*12+11,1)+epremium(k*12+10,1)+epremium(k*12+9,1)+epremium(k*12+8,1)+epremium(k*12+7,1)+epremium(k*12+6,1)+epremium(k*12+5,1)+...
        epremium(k*12+4,1)+epremium(k*12+3,1)+epremium(k*12+2,1)+epremium(k*12+1,1); 
end

data=[cg dg pd ret ir er];




